Index: res_config_mysql.c
===================================================================
--- res_config_mysql.c	(revision 365)
+++ res_config_mysql.c	(working copy)
@@ -164,15 +164,17 @@
 
 		while ((row = mysql_fetch_row(result))) {
 			for (i = 0; i < numFields; i++) {
-				for (stringp = ast_strdupa(row[i]), chunk = strsep(&stringp, ";"); chunk; chunk = strsep(&stringp, ";")) {
-					if (chunk && !ast_strlen_zero(ast_strip(chunk))) {
-						if (prev) {
-							prev->next = ast_variable_new(fields[i].name, chunk);
-							if (prev->next) {
-								prev = prev->next;
+				if (!ast_strlen_zero(row[i])) {
+					for (stringp = ast_strdupa(row[i]), chunk = strsep(&stringp, ";"); chunk; chunk = strsep(&stringp, ";")) {
+						if (chunk && !ast_strlen_zero(ast_strip(chunk))) {
+							if (prev) {
+								prev->next = ast_variable_new(fields[i].name, chunk);
+								if (prev->next) {
+									prev = prev->next;
+								}
+							} else {
+								prev = var = ast_variable_new(fields[i].name, chunk);
 							}
-						} else {
-							prev = var = ast_variable_new(fields[i].name, chunk);
 						}
 					}
 				}
@@ -792,14 +794,13 @@
 	} else
 		conn->port = atoi(s);
 
-	if (ast_strlen_zero(conn->host)) {
-		if (!(s = ast_variable_retrieve(config, "general", "dbsock"))) {
+	if (!(s = ast_variable_retrieve(config, "general", "dbsock"))) {
+		if (ast_strlen_zero(conn->host)) {
 			ast_log(LOG_WARNING, "MySQL RealTime: No database socket found, using '/tmp/mysql.sock' as default.\n");
-			s = "/tmp/mysql.sock";
+			ast_copy_string(conn->sock, "/tmp/mysql.sock", sizeof(conn->sock));
 		}
+	} else
 		ast_copy_string(conn->sock, s, sizeof(conn->sock));
-	} else
-		ast_copy_string(conn->sock, "", sizeof(conn->sock));
 
 	if (!ast_strlen_zero(conn->host)) {
 		ast_log(LOG_DEBUG, "MySQL RealTime host: %s\n", conn->host);
